import java.util.Scanner;

class TreeNode {
	
	public TreeNode left, right, parent;
	public int key;
	
	// Simple constructor
	public TreeNode(int newKey, TreeNode newParent) {
		key = newKey;
		left = null;
		right = null;
		parent = newParent;
	}
	
	// Print to System.out in a bracket-notation like "(1 (2)) 3 (4)" recursively
	// No newline printed. Note that building and returning a String would be cleaner
	// but much slower if not done carefully.
	public void print() {
		if (left != null) {
			System.out.print("(");
			left.print();
			System.out.print(") ");
		}
		System.out.print(key);
		if (right != null) {
			System.out.print(" (");
			right.print();
			System.out.print(")");
		}
	}
	
	/*** Methods to implement for 1 point */

	// Insert element "key" into the tree
	// You may assume that it is not there yet
	public void insert(int val) {
		// TODO: Implement the function
	}
	
	// Return if "key" is in the tree, recursively
	public boolean contains(int val) {
		// TODO: Implement the function
		return false;
	}

	// Delete "val" from the tree
	// You may assume that the tree contains "val"
	public void delete(int val) {
		// TODO: Implement the function
	}

	/*** Methods to implement for another 1 point */
	
	// Find "rank"-th smallest element in the tree, counting from 0
	public int findByRank(int rank) {
		// TODO: Implement the function
		return -1;
	}
}


/* NB: For the judge to run the program, do not modify the declaration of the class Main or
 *     method main() below. The class has to be declared as "class Main { ... }"
 *     and the method as "public static void main(String[] args) { ... }" */
class Main {

	public static void main(String[] args) {

		// Read from the standard input with java.util.Scanner
		Scanner scanner = new Scanner(System.in);
		boolean run = true;
		
		// We use a "special" smallest value node as a root.
		// Always having at least one node of the tree simplifies a lot of special cases. 
		TreeNode root = new TreeNode(-1, null);

		// A simple loop reading one command at a time
		while (run) {
			String cmd = scanner.next();
			
			if (cmd.equals("I")) {
				int val = scanner.nextInt();
				root.insert(val);
			}
			
			if (cmd.equals("D")) {
				int val = scanner.nextInt();
				root.delete(val);
			}
			
			if (cmd.equals("C")) {
				int val = scanner.nextInt();
				if (root.contains(val)) {
					System.out.println("YES");
				} else {
					System.out.println("NO");
				}
			}
			
			if (cmd.equals("P")) {
				// We are not printing the special "-1" node
				if (root.right == null) {
					System.out.println("EMPTY");
				} else {
					root.right.print();
					System.out.println();
				}
			}
			
			if (cmd.equals("R")) {
				int rank = scanner.nextInt();
				// We look for element number "rank+1" to skip the special "-1" value
				System.out.println(root.findByRank(rank + 1));
			}

			if (cmd.equals("X")) {
				run = false;
			}
		}
		scanner.close();
	}
}
